'This module defines a form for adding new variables to a knowledge base.
'This form is also used to allow users to edit some of the properties of
'an existing variable.

'The user must name the variable, provide the type, specific values
'for the variable if applicable, a question to pose to the user at run-time, 
'and whether the variable is a goal for the knowledge base or initial data, 
'which means the run-time user will be asked to provide a value at the 
'beginning of the run.
'
' Original Code by James Collins
' Added to and expanded by Mike, Brian, Brett
' Form designed by James

'Form design modified and code altered by the FreeShell Live team - fall 2005.

Option Strict Off
Option Explicit On 
Friend Class frmAddVariable
	Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
	Public Sub New()
		MyBase.New()
		If m_vb6FormDefInstance Is Nothing Then
			If m_InitializingDefInstance Then
				m_vb6FormDefInstance = Me
			Else
				Try 
					'For the start-up form, the first instance created is the default instance.
					If System.Reflection.Assembly.GetExecutingAssembly.EntryPoint.DeclaringType Is Me.GetType Then
						m_vb6FormDefInstance = Me
					End If
				Catch
				End Try
			End If
		End If
		'This call is required by the Windows Form Designer.
		InitializeComponent()
	End Sub
	'Form overrides dispose to clean up the component list.
	Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
		If Disposing Then
			If Not components Is Nothing Then
				components.Dispose()
			End If
		End If
		MyBase.Dispose(Disposing)
	End Sub
	'Required by the Windows Form Designer
	Private components As System.ComponentModel.IContainer
	Public ToolTip1 As System.Windows.Forms.ToolTip
    Public WithEvents txtQuestion As System.Windows.Forms.TextBox
	Public WithEvents btnRemove As System.Windows.Forms.Button
	Public WithEvents btnAdd As System.Windows.Forms.Button
	Public WithEvents txtNewElement As System.Windows.Forms.TextBox
	Public WithEvents txtSpecify2 As System.Windows.Forms.TextBox
	Public WithEvents txtSpecify1 As System.Windows.Forms.TextBox
	Public WithEvents optSpecify As System.Windows.Forms.RadioButton
	Public WithEvents optDefault As System.Windows.Forms.RadioButton
	Public WithEvents lstStaticList As System.Windows.Forms.ListBox
	Public WithEvents lblBoolean As System.Windows.Forms.Label
	Public WithEvents lblTo As System.Windows.Forms.Label
	Public WithEvents fraValues As System.Windows.Forms.GroupBox
	Public WithEvents cboType As System.Windows.Forms.ComboBox
	Public WithEvents txtName As System.Windows.Forms.TextBox
	Public WithEvents btnCancel As System.Windows.Forms.Button
	Public WithEvents btnOK As System.Windows.Forms.Button
	Public WithEvents lblQuestion As System.Windows.Forms.Label
	Public WithEvents lblType As System.Windows.Forms.Label
	Public WithEvents lblName As System.Windows.Forms.Label
	'NOTE: The following procedure is required by the Windows Form Designer
	'It can be modified using the Windows Form Designer.
	'Do not modify it using the code editor.
    Friend WithEvents chkInitialData As System.Windows.Forms.RadioButton
    Friend WithEvents chkGoal As System.Windows.Forms.RadioButton
    Friend WithEvents chkAskable As System.Windows.Forms.RadioButton
    Friend WithEvents chkNotAskable As System.Windows.Forms.RadioButton
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(frmAddVariable))
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.txtQuestion = New System.Windows.Forms.TextBox
        Me.fraValues = New System.Windows.Forms.GroupBox
        Me.btnRemove = New System.Windows.Forms.Button
        Me.btnAdd = New System.Windows.Forms.Button
        Me.txtNewElement = New System.Windows.Forms.TextBox
        Me.txtSpecify2 = New System.Windows.Forms.TextBox
        Me.txtSpecify1 = New System.Windows.Forms.TextBox
        Me.optSpecify = New System.Windows.Forms.RadioButton
        Me.optDefault = New System.Windows.Forms.RadioButton
        Me.lstStaticList = New System.Windows.Forms.ListBox
        Me.lblBoolean = New System.Windows.Forms.Label
        Me.lblTo = New System.Windows.Forms.Label
        Me.cboType = New System.Windows.Forms.ComboBox
        Me.txtName = New System.Windows.Forms.TextBox
        Me.btnCancel = New System.Windows.Forms.Button
        Me.btnOK = New System.Windows.Forms.Button
        Me.lblQuestion = New System.Windows.Forms.Label
        Me.lblType = New System.Windows.Forms.Label
        Me.lblName = New System.Windows.Forms.Label
        Me.chkInitialData = New System.Windows.Forms.RadioButton
        Me.chkGoal = New System.Windows.Forms.RadioButton
        Me.chkAskable = New System.Windows.Forms.RadioButton
        Me.chkNotAskable = New System.Windows.Forms.RadioButton
        Me.fraValues.SuspendLayout()
        Me.SuspendLayout()
        '
        'txtQuestion
        '
        Me.txtQuestion.AcceptsReturn = True
        Me.txtQuestion.AutoSize = False
        Me.txtQuestion.BackColor = System.Drawing.SystemColors.Window
        Me.txtQuestion.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.txtQuestion.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtQuestion.ForeColor = System.Drawing.SystemColors.WindowText
        Me.txtQuestion.Location = New System.Drawing.Point(8, 80)
        Me.txtQuestion.MaxLength = 0
        Me.txtQuestion.Multiline = True
        Me.txtQuestion.Name = "txtQuestion"
        Me.txtQuestion.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtQuestion.Size = New System.Drawing.Size(225, 64)
        Me.txtQuestion.TabIndex = 2
        Me.txtQuestion.Text = ""
        '
        'fraValues
        '
        Me.fraValues.BackColor = System.Drawing.SystemColors.Control
        Me.fraValues.Controls.Add(Me.btnRemove)
        Me.fraValues.Controls.Add(Me.btnAdd)
        Me.fraValues.Controls.Add(Me.txtNewElement)
        Me.fraValues.Controls.Add(Me.txtSpecify2)
        Me.fraValues.Controls.Add(Me.txtSpecify1)
        Me.fraValues.Controls.Add(Me.optSpecify)
        Me.fraValues.Controls.Add(Me.optDefault)
        Me.fraValues.Controls.Add(Me.lstStaticList)
        Me.fraValues.Controls.Add(Me.lblBoolean)
        Me.fraValues.Controls.Add(Me.lblTo)
        Me.fraValues.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.fraValues.ForeColor = System.Drawing.SystemColors.ControlText
        Me.fraValues.Location = New System.Drawing.Point(8, 152)
        Me.fraValues.Name = "fraValues"
        Me.fraValues.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.fraValues.Size = New System.Drawing.Size(337, 209)
        Me.fraValues.TabIndex = 19
        Me.fraValues.TabStop = False
        Me.fraValues.Text = "Values"
        '
        'btnRemove
        '
        Me.btnRemove.BackColor = System.Drawing.SystemColors.Control
        Me.btnRemove.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnRemove.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnRemove.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnRemove.Location = New System.Drawing.Point(256, 64)
        Me.btnRemove.Name = "btnRemove"
        Me.btnRemove.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnRemove.Size = New System.Drawing.Size(65, 25)
        Me.btnRemove.TabIndex = 7
        Me.btnRemove.Text = "Remove"
        Me.btnRemove.Visible = False
        '
        'btnAdd
        '
        Me.btnAdd.BackColor = System.Drawing.SystemColors.Control
        Me.btnAdd.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnAdd.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnAdd.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnAdd.Location = New System.Drawing.Point(256, 24)
        Me.btnAdd.Name = "btnAdd"
        Me.btnAdd.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnAdd.Size = New System.Drawing.Size(65, 25)
        Me.btnAdd.TabIndex = 6
        Me.btnAdd.Text = "&Add"
        Me.btnAdd.Visible = False
        '
        'txtNewElement
        '
        Me.txtNewElement.AcceptsReturn = True
        Me.txtNewElement.AutoSize = False
        Me.txtNewElement.BackColor = System.Drawing.SystemColors.Window
        Me.txtNewElement.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.txtNewElement.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtNewElement.ForeColor = System.Drawing.SystemColors.WindowText
        Me.txtNewElement.Location = New System.Drawing.Point(8, 24)
        Me.txtNewElement.MaxLength = 0
        Me.txtNewElement.Name = "txtNewElement"
        Me.txtNewElement.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtNewElement.Size = New System.Drawing.Size(233, 19)
        Me.txtNewElement.TabIndex = 5
        Me.txtNewElement.Text = ""
        Me.txtNewElement.Visible = False
        '
        'txtSpecify2
        '
        Me.txtSpecify2.AcceptsReturn = True
        Me.txtSpecify2.AutoSize = False
        Me.txtSpecify2.BackColor = System.Drawing.SystemColors.Window
        Me.txtSpecify2.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.txtSpecify2.Enabled = False
        Me.txtSpecify2.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtSpecify2.ForeColor = System.Drawing.SystemColors.WindowText
        Me.txtSpecify2.Location = New System.Drawing.Point(224, 104)
        Me.txtSpecify2.MaxLength = 0
        Me.txtSpecify2.Name = "txtSpecify2"
        Me.txtSpecify2.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtSpecify2.Size = New System.Drawing.Size(65, 19)
        Me.txtSpecify2.TabIndex = 11
        Me.txtSpecify2.Text = ""
        Me.txtSpecify2.Visible = False
        '
        'txtSpecify1
        '
        Me.txtSpecify1.AcceptsReturn = True
        Me.txtSpecify1.AutoSize = False
        Me.txtSpecify1.BackColor = System.Drawing.SystemColors.Window
        Me.txtSpecify1.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.txtSpecify1.Enabled = False
        Me.txtSpecify1.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtSpecify1.ForeColor = System.Drawing.SystemColors.WindowText
        Me.txtSpecify1.Location = New System.Drawing.Point(128, 104)
        Me.txtSpecify1.MaxLength = 0
        Me.txtSpecify1.Name = "txtSpecify1"
        Me.txtSpecify1.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtSpecify1.Size = New System.Drawing.Size(65, 19)
        Me.txtSpecify1.TabIndex = 10
        Me.txtSpecify1.Text = ""
        Me.txtSpecify1.Visible = False
        '
        'optSpecify
        '
        Me.optSpecify.BackColor = System.Drawing.SystemColors.Control
        Me.optSpecify.Cursor = System.Windows.Forms.Cursors.Default
        Me.optSpecify.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.optSpecify.ForeColor = System.Drawing.SystemColors.ControlText
        Me.optSpecify.Location = New System.Drawing.Point(64, 104)
        Me.optSpecify.Name = "optSpecify"
        Me.optSpecify.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.optSpecify.Size = New System.Drawing.Size(65, 17)
        Me.optSpecify.TabIndex = 9
        Me.optSpecify.TabStop = True
        Me.optSpecify.Text = "Specify:"
        Me.optSpecify.Visible = False
        '
        'optDefault
        '
        Me.optDefault.BackColor = System.Drawing.SystemColors.Control
        Me.optDefault.Checked = True
        Me.optDefault.Cursor = System.Windows.Forms.Cursors.Default
        Me.optDefault.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.optDefault.ForeColor = System.Drawing.SystemColors.ControlText
        Me.optDefault.Location = New System.Drawing.Point(64, 80)
        Me.optDefault.Name = "optDefault"
        Me.optDefault.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.optDefault.Size = New System.Drawing.Size(65, 17)
        Me.optDefault.TabIndex = 8
        Me.optDefault.TabStop = True
        Me.optDefault.Text = "Default"
        Me.optDefault.Visible = False
        '
        'lstStaticList
        '
        Me.lstStaticList.BackColor = System.Drawing.SystemColors.Window
        Me.lstStaticList.Cursor = System.Windows.Forms.Cursors.Default
        Me.lstStaticList.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lstStaticList.ForeColor = System.Drawing.SystemColors.WindowText
        Me.lstStaticList.ItemHeight = 14
        Me.lstStaticList.Location = New System.Drawing.Point(8, 64)
        Me.lstStaticList.Name = "lstStaticList"
        Me.lstStaticList.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lstStaticList.Size = New System.Drawing.Size(233, 116)
        Me.lstStaticList.TabIndex = 18
        Me.lstStaticList.Visible = False
        '
        'lblBoolean
        '
        Me.lblBoolean.BackColor = System.Drawing.SystemColors.Control
        Me.lblBoolean.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblBoolean.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblBoolean.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblBoolean.Location = New System.Drawing.Point(24, 96)
        Me.lblBoolean.Name = "lblBoolean"
        Me.lblBoolean.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblBoolean.Size = New System.Drawing.Size(281, 17)
        Me.lblBoolean.TabIndex = 16
        Me.lblBoolean.Text = "Boolean variables have either a True or False value."
        Me.lblBoolean.TextAlign = System.Drawing.ContentAlignment.TopCenter
        Me.lblBoolean.Visible = False
        '
        'lblTo
        '
        Me.lblTo.BackColor = System.Drawing.SystemColors.Control
        Me.lblTo.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblTo.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblTo.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblTo.Location = New System.Drawing.Point(200, 104)
        Me.lblTo.Name = "lblTo"
        Me.lblTo.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblTo.Size = New System.Drawing.Size(17, 17)
        Me.lblTo.TabIndex = 17
        Me.lblTo.Text = "To"
        Me.lblTo.Visible = False
        '
        'cboType
        '
        Me.cboType.BackColor = System.Drawing.SystemColors.Window
        Me.cboType.Cursor = System.Windows.Forms.Cursors.Default
        Me.cboType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
        Me.cboType.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cboType.ForeColor = System.Drawing.SystemColors.WindowText
        Me.cboType.Items.AddRange(New Object() {"Boolean", "Numeric Range", "Static List"})
        Me.cboType.Location = New System.Drawing.Point(240, 32)
        Me.cboType.Name = "cboType"
        Me.cboType.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.cboType.Size = New System.Drawing.Size(105, 22)
        Me.cboType.Sorted = True
        Me.cboType.TabIndex = 1
        '
        'txtName
        '
        Me.txtName.AcceptsReturn = True
        Me.txtName.AutoSize = False
        Me.txtName.BackColor = System.Drawing.SystemColors.Window
        Me.txtName.Cursor = System.Windows.Forms.Cursors.IBeam
        Me.txtName.Font = New System.Drawing.Font("Arial", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.txtName.ForeColor = System.Drawing.SystemColors.WindowText
        Me.txtName.Location = New System.Drawing.Point(8, 32)
        Me.txtName.MaxLength = 0
        Me.txtName.Name = "txtName"
        Me.txtName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.txtName.Size = New System.Drawing.Size(225, 22)
        Me.txtName.TabIndex = 0
        Me.txtName.Text = ""
        '
        'btnCancel
        '
        Me.btnCancel.BackColor = System.Drawing.SystemColors.Control
        Me.btnCancel.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btnCancel.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnCancel.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnCancel.Location = New System.Drawing.Point(264, 376)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnCancel.Size = New System.Drawing.Size(73, 25)
        Me.btnCancel.TabIndex = 13
        Me.btnCancel.Text = "Cancel"
        '
        'btnOK
        '
        Me.btnOK.BackColor = System.Drawing.SystemColors.Control
        Me.btnOK.Cursor = System.Windows.Forms.Cursors.Default
        Me.btnOK.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btnOK.ForeColor = System.Drawing.SystemColors.ControlText
        Me.btnOK.Location = New System.Drawing.Point(176, 376)
        Me.btnOK.Name = "btnOK"
        Me.btnOK.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.btnOK.Size = New System.Drawing.Size(73, 25)
        Me.btnOK.TabIndex = 12
        Me.btnOK.Text = "OK"
        '
        'lblQuestion
        '
        Me.lblQuestion.BackColor = System.Drawing.SystemColors.Control
        Me.lblQuestion.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblQuestion.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblQuestion.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblQuestion.Location = New System.Drawing.Point(8, 64)
        Me.lblQuestion.Name = "lblQuestion"
        Me.lblQuestion.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblQuestion.Size = New System.Drawing.Size(72, 17)
        Me.lblQuestion.TabIndex = 20
        Me.lblQuestion.Text = "Question:"
        '
        'lblType
        '
        Me.lblType.BackColor = System.Drawing.SystemColors.Control
        Me.lblType.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblType.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblType.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblType.Location = New System.Drawing.Point(240, 16)
        Me.lblType.Name = "lblType"
        Me.lblType.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblType.Size = New System.Drawing.Size(87, 17)
        Me.lblType.TabIndex = 15
        Me.lblType.Text = "Variable Type:"
        '
        'lblName
        '
        Me.lblName.BackColor = System.Drawing.SystemColors.Control
        Me.lblName.Cursor = System.Windows.Forms.Cursors.Default
        Me.lblName.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblName.ForeColor = System.Drawing.SystemColors.ControlText
        Me.lblName.Location = New System.Drawing.Point(8, 16)
        Me.lblName.Name = "lblName"
        Me.lblName.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.lblName.Size = New System.Drawing.Size(81, 17)
        Me.lblName.TabIndex = 14
        Me.lblName.Text = "Variable Name:"
        '
        'chkInitialData
        '
        Me.chkInitialData.Location = New System.Drawing.Point(256, 80)
        Me.chkInitialData.Name = "chkInitialData"
        Me.chkInitialData.Size = New System.Drawing.Size(80, 16)
        Me.chkInitialData.TabIndex = 22
        Me.chkInitialData.Text = "Initial Data"
        '
        'chkGoal
        '
        Me.chkGoal.Location = New System.Drawing.Point(256, 96)
        Me.chkGoal.Name = "chkGoal"
        Me.chkGoal.Size = New System.Drawing.Size(48, 16)
        Me.chkGoal.TabIndex = 23
        Me.chkGoal.Text = "Goal"
        '
        'chkAskable
        '
        Me.chkAskable.Location = New System.Drawing.Point(256, 112)
        Me.chkAskable.Name = "chkAskable"
        Me.chkAskable.Size = New System.Drawing.Size(64, 16)
        Me.chkAskable.TabIndex = 24
        Me.chkAskable.Text = "Askable"
        '
        'chkNotAskable
        '
        Me.chkNotAskable.Location = New System.Drawing.Point(256, 128)
        Me.chkNotAskable.Name = "chkNotAskable"
        Me.chkNotAskable.Size = New System.Drawing.Size(88, 16)
        Me.chkNotAskable.TabIndex = 25
        Me.chkNotAskable.Text = "Not Askable"
        '
        'frmAddVariable
        '
        Me.AcceptButton = Me.btnOK
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.SystemColors.Control
        Me.CancelButton = Me.btnCancel
        Me.ClientSize = New System.Drawing.Size(356, 414)
        Me.Controls.Add(Me.chkNotAskable)
        Me.Controls.Add(Me.chkAskable)
        Me.Controls.Add(Me.chkGoal)
        Me.Controls.Add(Me.chkInitialData)
        Me.Controls.Add(Me.txtQuestion)
        Me.Controls.Add(Me.fraValues)
        Me.Controls.Add(Me.cboType)
        Me.Controls.Add(Me.txtName)
        Me.Controls.Add(Me.btnCancel)
        Me.Controls.Add(Me.btnOK)
        Me.Controls.Add(Me.lblQuestion)
        Me.Controls.Add(Me.lblType)
        Me.Controls.Add(Me.lblName)
        Me.Cursor = System.Windows.Forms.Cursors.Default
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Location = New System.Drawing.Point(218, 301)
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "frmAddVariable"
        Me.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent
        Me.Text = "Add Variable"
        Me.fraValues.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub
#End Region 
#Region "Upgrade Support "
	Private Shared m_vb6FormDefInstance As frmAddVariable
	Private Shared m_InitializingDefInstance As Boolean
	Public Shared Property DefInstance() As frmAddVariable
		Get
			If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
				m_InitializingDefInstance = True
				m_vb6FormDefInstance = New frmAddVariable()
				m_InitializingDefInstance = False
			End If
			DefInstance = m_vb6FormDefInstance
		End Get
		Set
			m_vb6FormDefInstance = Value
		End Set
	End Property
#End Region

    'btnAdd_Click
    'Handler for the form's "Add" button. This function adds an option to
    'the static list data for the variable.
    Private Sub btnAdd_Click(ByVal eventSender As System.Object, _
    ByVal eventArgs As System.EventArgs) Handles btnAdd.Click

        'The string to be added to the list
        Dim strTextToAdd As String

        If txtNewElement.Text <> vbNullString Then
            'remove any pound signs from the string before adding it
            'this allows them to be used as delimiters when storing the string
            strTextToAdd = Trim(Replace(txtNewElement.Text, "#", ""))

            If Len(strTextToAdd) <> 0 Then lstStaticList.Items.Add((strTextToAdd))
            txtNewElement.Text = vbNullString
        Else
            MsgBox("You must enter a name for the static list element.", _
            MsgBoxStyle.OKOnly)
        End If
        txtNewElement.Focus()
    End Sub

    'btnRemove_Click
    'Handelr for the form's "Remove" button. this function removes an option
    'from the static list data for the variable.
    Private Sub btnRemove_Click(ByVal eventSender As System.Object, _
    ByVal eventArgs As System.EventArgs) Handles btnRemove.Click
        ' Remove value from static list

        Dim intIndex As Short

        With lstStaticList
            If .Items.Count > 0 Then
                intIndex = .SelectedIndex
                If intIndex > -1 Then ' if a value is selected, remove it
                    .Items.RemoveAt((intIndex))
                    .Focus()
                    .SelectedIndex = intIndex - 1
                End If
            End If
        End With
    End Sub


    'btnCancel_Click
    'Handler for the cancel button. This just resets some of the controls
    'on the form and then hides it.
    Private Sub btnCancel_Click(ByVal eventSender As System.Object, _
    ByVal eventArgs As System.EventArgs) Handles btnCancel.Click
        ' Just hide the form
        Me.Hide()
    End Sub

    'cboType_SelectedIndexChanged

    Private Sub cboType_SelectedIndexChanged(ByVal eventSender As System.Object, _
    ByVal eventArgs As System.EventArgs) Handles cboType.SelectedIndexChanged
        ' Show/Hide specific value attributes based on what type of variable is selected

        ' initialize form components

        optDefault.Visible = False
        optSpecify.Visible = False
        txtSpecify1.Visible = False
        txtSpecify2.Visible = False
        txtSpecify1.Enabled = False
        txtSpecify2.Enabled = False
        txtSpecify1.BackColor = System.Drawing.SystemColors.InactiveCaptionText
        txtSpecify2.BackColor = System.Drawing.SystemColors.InactiveCaptionText
        lblTo.Visible = False
        txtNewElement.Visible = False
        VB6.SetDefault(btnOK, True)
        VB6.SetDefault(btnAdd, False)
        btnAdd.Visible = False
        btnRemove.Visible = False
        lstStaticList.Visible = False
        lblBoolean.Visible = False

        Select Case cboType.SelectedIndex
            Case 0 ' Boolean selected
                lblBoolean.Visible = True
            Case 1 ' Numeric Range selected, display the appropriate components
                optDefault.Visible = True
                optDefault.Checked = True
                optSpecify.Visible = True
                txtSpecify1.Visible = True
                txtSpecify2.Visible = True
                lblTo.Visible = True
            Case 2 ' Static List selected, display the appropriate components
                txtNewElement.Visible = True
                btnAdd.Visible = True
                btnRemove.Visible = True
                lstStaticList.Visible = True
                VB6.SetDefault(btnOK, False)
                VB6.SetDefault(btnAdd, True)
        End Select

    End Sub

    'UPGRADE_WARNING: Form event frmAddVariable.Activate has a new behavior. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup2065"'
    Private Sub frmAddVariable_Activated(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Activated


    End Sub

    Public Sub btnOK_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles btnOK.Click
        ' Add variable properties to listview control in frmVariableEditor and the listview
        ' control in frmRuleCreator
        ' The listview control has the following columns:
        '                   1) variable name
        '                   2) variable type
        '                   3) variable values
        '                   4) number of values stored in static list, if applicable
        '                   5) "G"oal, "I"dentity, "A"skable, or "N"one
        '                   6) question
        '

        ' error checking for invalid variable

        Dim strList As String
        Dim intIndex As Short
        Dim NewVariableEditorItem As mscomctl.ListItem  ' item to be added to frmVariableEditor.lvwVariables
        Dim NewRuleCreatorItem As mscomctl.ListItem ' item to be added to frmRuleCreator.lvwVariables 
        Dim NewRuleCreatorItem2 As mscomctl.ListItem
        If txtName.Text = vbNullString Then
            MsgBox("You must enter a name for the variable.", MsgBoxStyle.OKOnly)
            txtName.Focus()
        ElseIf InStr(txtName.Text, " ") <> 0 Then
            MsgBox("No spaces are allowed in a variable name.", MsgBoxStyle.OKOnly)
            txtName.Focus()
        ElseIf chkGoal.Checked And txtQuestion.Text <> vbNullString Then
            MsgBox("Goal variables cannot have questions.", MsgBoxStyle.OKOnly)
        ElseIf chkInitialData.Checked And txtQuestion.Text = vbNullString Then
            MsgBox("An initial variable must have a question.", MsgBoxStyle.OKOnly)
        ElseIf chkAskable.Checked And txtQuestion.Text = vbNullString Then
            MsgBox("An askable variable must have a question.", MsgBoxStyle.OKOnly)
        ElseIf ((cboType.SelectedIndex = 1) And (optSpecify.Checked = True) And ((txtSpecify1.Text = vbNullString) Or (Not IsNumeric(txtSpecify1.Text)))) Then
            MsgBox("You must enter a valid minimum value for the range.", MsgBoxStyle.OKOnly)
            txtSpecify1.Focus()
        ElseIf ((cboType.SelectedIndex = 1) And (optSpecify.Checked = True) And ((txtSpecify2.Text = vbNullString) Or (Not IsNumeric(txtSpecify2.Text)))) Then
            MsgBox("You must enter a valid maximum value for the range.", MsgBoxStyle.OKOnly)
            txtSpecify2.Focus()
        Else ' valid variable, OK to add

            ' the necessary structures & syntax for adding to a listview control

            If frmAddVariable.DefInstance.Text = "Add Variable" Then
                frmRuleCreator.DefInstance.cbIfVariable.Items.Add(Trim(txtName.Text))
                frmRuleCreator.DefInstance.cbThenVariable.Items.Add(Trim(txtName.Text))

                'NewRuleCreatorItem2 = frmRuleCreator.DefInstance.lvwVariables2.ListItems.Add()
                NewVariableEditorItem = frmMain.DefInstance.lvwVariables.ListItems.Add()
            Else ' Edit Variable, so replace what is already there
                NewVariableEditorItem = frmMain.DefInstance.lvwVariables.ListItems.Item(frmMain.DefInstance.lvwVariables.SelectedItem.Index)
                frmRuleCreator.DefInstance.cbIfVariable.Items(frmMain.DefInstance.lvwVariables.SelectedItem.Index - 1) = Trim(txtName.Text)
                frmRuleCreator.DefInstance.cbThenVariable.Items(frmMain.DefInstance.lvwVariables.SelectedItem.Index - 1) = Trim(txtName.Text)

                'NewRuleCreatorItem2 = frmRuleCreator.DefInstance.lvwVariables2.ListItems.Item(frmMain.DefInstance.lvwVariables.SelectedItem.Index)
            End If

            With NewVariableEditorItem

                Select Case cboType.SelectedIndex
                    Case 0 ' Boolean
                        strList = "B"
                    Case 1 ' Numeric Range
                        If optDefault.Checked = True Then
                            strList = "N Default"
                        Else
                            strList = "N " & txtSpecify1.Text & " # " & txtSpecify2.Text
                        End If
                    Case 2 ' Static List
                        If lstStaticList.Items.Count > 0 Then
                            strList = "S " & VB6.GetItemString(lstStaticList, 0) & " # "
                            If lstStaticList.Items.Count > 1 Then
                                For intIndex = 1 To lstStaticList.Items.Count - 1
                                    strList = strList & VB6.GetItemString(lstStaticList, intIndex) & " # "
                                Next intIndex
                            End If
                        Else
                            MsgBox("Static List cannot be empty.  Please add elements to the list.", MsgBoxStyle.OKOnly, "Empty List")
                        End If
                        .SubItems(3) = CStr(lstStaticList.Items.Count)
                End Select

                .Text = Trim(txtName.Text)
                .SubItems(1) = cboType.Text
                .SubItems(2) = strList
                .SubItems(4) = txtQuestion.Text

                If chkGoal.Checked Then
                    .SubItems(5) = "G"
                ElseIf chkInitialData.Checked Then
                    .SubItems(5) = "I"
                ElseIf chkAskable.Checked Then
                    .SubItems(5) = "A"
                Else
                    .SubItems(5) = "N"
                End If

            End With

            'NewRuleCreatorItem.Text = Trim(txtName.Text)
            'NewRuleCreatorItem.SubItems(1) = cboType.Text
            'NewRuleCreatorItem.SubItems(2) = strList

            'NewRuleCreatorItem2.Text = Trim(txtName.Text)
            'NewRuleCreatorItem2.SubItems(1) = cboType.Text
            'NewRuleCreatorItem2.SubItems(2) = strList

            chkAskable.Checked = False
            chkGoal.Checked = False
            chkInitialData.Checked = False
            'chkInitialData.Enabled = True
            'chkGoal.Enabled = True
            'chkAskable.Enabled = True


            Me.Hide()
        End If

    End Sub

    'UPGRADE_WARNING: Event optDefault.CheckedChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup2075"'
    Private Sub optDefault_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optDefault.CheckedChanged
        If eventSender.Checked Then
            ' Disable text boxes for entering a specific numerical range

            txtSpecify1.Enabled = False
            txtSpecify2.Enabled = False
            txtSpecify1.BackColor = System.Drawing.SystemColors.InactiveCaptionText
            txtSpecify2.BackColor = System.Drawing.SystemColors.InactiveCaptionText

        End If
    End Sub

    'UPGRADE_WARNING: Event optSpecify.CheckedChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="vbup2075"'
    Private Sub optSpecify_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles optSpecify.CheckedChanged
        If eventSender.Checked Then
            ' Enable text boxes for entering a specific numerical range

            txtSpecify1.Enabled = True
            txtSpecify2.Enabled = True
            txtSpecify1.BackColor = System.Drawing.Color.White
            txtSpecify2.BackColor = System.Drawing.Color.White

        End If
    End Sub

    Private Sub frmAddVariable_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub

    Private Sub frmAddVariable_VisibleChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.VisibleChanged
        ' Clear all controls and set focus to txtName

        If frmAddVariable.DefInstance.Text = "Add Variable" Then
            cboType.SelectedIndex = 0
            optDefault.Checked = False
            optSpecify.Checked = False
            txtSpecify1.Text = vbNullString
            txtSpecify2.Text = vbNullString
            txtNewElement.Text = vbNullString
            lstStaticList.Items.Clear()
            txtQuestion.Text = vbNullString
            'chkGoal.Checked = False
            chkInitialData.Checked = True
            'chkAskable.Checked = False
            txtName.Text = vbNullString
            txtName.Enabled = True
            cboType.Enabled = True
            txtName.Focus()
            VB6.SetDefault(btnOK, True)
            VB6.SetDefault(btnAdd, False)
            'chkAskable.Enabled = True
            chkInitialData.Enabled = True
            'chkGoal.Enabled = True
        Else
            txtQuestion.Focus()
        End If
    End Sub
End Class